import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Fernseher here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Fernseher extends ZimmerObject
{   
    final static int ON = 0;
    final static int OFF = 1;
    final static int STANDBY = 2;
    final static int SWITCH = 3;
    final static int CRASH = 4;
    
    final static int HERZ = 1;
    final static int AUTO = 2;
    
    int onOff=ON;
    int switcher=HERZ;
    
    private FernOn onbutton;
    private FernOff offbutton;
    private FernStandby standbybutton;
    private FernSwitch switchbutton;
    private Finisher f;
    
    public void act() 
    {
        onclicker();
        imager();
        end();
        
    }
    
    public void end(){
        if((onOff == OFF || onOff==CRASH) && Greenfoot.mousePressed(((Welt)getWorld()).f)){
            getWorld().addObject(new Hackchen(), 460, 80);
            getWorld().removeObject(this);
        }else if((onOff != OFF || onOff!=CRASH) && Greenfoot.mousePressed(((Welt)getWorld()).f)){
            getWorld().removeObject(this);
        }
    }
    
    public void imager(){
      if(onOff==ON){
            setImage("FernseherL.png");
        }else if(onOff==OFF || onOff==CRASH){
            setImage("FernseherO.png");
        }else if(onOff==STANDBY){
            setImage("FernseherS.png");
        }else if(switcher==HERZ && onOff==SWITCH){
            setImage("FernseherP.png");
        }else if(switcher==AUTO && onOff==SWITCH){
            setImage("FernseherL.png");
        }
   }
    
    public void onclicker(){
      if(onOff != CRASH){
        if(Greenfoot.mousePressed(this)){
            if(onOff==ON){
                offbutton = new FernOff(this);
                getWorld().addObject(offbutton, 210, 50);
                standbybutton = new FernStandby(this);
                getWorld().addObject(standbybutton, 440, 50);
                switchbutton = new FernSwitch(this);
                getWorld().addObject(switchbutton, 270, 150);
            }else if(onOff==OFF){
                onbutton = new FernOn(this);
                getWorld().addObject(onbutton, 440, 50);
            }else if(onOff==STANDBY){
                onbutton = new FernOn(this);
                getWorld().addObject(onbutton, 270, 150);
                offbutton = new FernOff(this);
                getWorld().addObject(offbutton, 210, 50);
            }else if(onOff==SWITCH){
                offbutton = new FernOff(this);
                getWorld().addObject(offbutton, 210, 50);
                standbybutton = new FernStandby(this);
                getWorld().addObject(standbybutton, 440, 50);
                switchbutton = new FernSwitch(this);
                getWorld().addObject(switchbutton, 270, 150);
            }
        }
      }
    }
    
    public void stateChange(int state) {
        onOff = state;
        if(onbutton!=null) {
            getWorld().removeObject(onbutton);
            onbutton = null;
        }
        if(offbutton != null) {
            getWorld().removeObject(offbutton);
            offbutton = null;
        }
        if(standbybutton != null) {
            getWorld().removeObject(standbybutton);
            standbybutton = null;
        }
        if(switchbutton != null){
            getWorld().removeObject(switchbutton);
            switchbutton = null;
        }
    }
}
