import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Stecki here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Stecki extends ZimmerObject
{
    final static int ON = 0;
    final static int OFF = 1;
    final static int STANDBY = 2;
    final static int SWITCH = 3;
    final static int DECRASH = 4;
    final static int TOTALCRASH = 5;
    
    int onOff=ON;
    int lamp=DECRASH;
    int fern=DECRASH;
    int pcstater=DECRASH;
    
    private SteckiOn onbutton;
    private SteckiOff offbutton;
    private Finisher f;
    
    private Lampe mylamp;
    private Pc pc;
    private Fernseher myfern;
    
    public Stecki(Lampe mylamp, Fernseher myfern) {
        this.mylamp = mylamp;
        this.myfern = myfern;
   }

    
    public void act() 
    {
        onclicker();
        imager();
        end();
        crasher();
        decrasher();
        
    }
    
    public void addedToWorld(World w) {
        super.addedToWorld(w);
        pc = ((Welt)w).pc;
    }
    
    public void decrasher(){
        
        if(onOff==ON && pcstater != DECRASH && pcstater != TOTALCRASH){
            pc.stateChange(pcstater);
            pcstater=DECRASH;
        }
        
        if(onOff==ON && lamp != DECRASH){
            mylamp.stateChange(lamp);
            lamp=DECRASH;
        }
        
        if(onOff==ON && fern != DECRASH){
            myfern.stateChange(fern);
            fern=DECRASH;
        }
    }
            
    public void crasher(){
        
        if(onOff == OFF && pc.onOff == pc.PCON){
            getWorld().addObject(new Meldung1(),250,150);
            pc.stateChange(Pc.CRASH);
            pcstater=TOTALCRASH;
        }else if(onOff == OFF && pc.onOff == pc.PCSTANDBY){
            pc.stateChange(Pc.CRASH);
            pcstater=STANDBY;
        }
        
        if(onOff == OFF && mylamp.onOff==mylamp.ON){
            mylamp.stateChange(Lampe.CRASH);
            lamp=ON;
        }
        
        if(onOff == OFF && myfern.onOff==myfern.ON){
            myfern.stateChange(Fernseher.CRASH);
            fern=ON;
        }else if(onOff == OFF && myfern.onOff==myfern.SWITCH){
            myfern.stateChange(Fernseher.CRASH);
            fern=SWITCH;
        }else if(onOff == OFF && myfern.onOff==myfern.STANDBY){
            myfern.stateChange(Fernseher.CRASH);
            fern=STANDBY;
        }
    }
    
    public void end(){
        if(onOff == OFF && Greenfoot.mousePressed(((Welt)getWorld()).f)){
            getWorld().addObject(new Hackchen(), 460, 230);
            getWorld().removeObject(this);
        }else if(onOff != OFF && Greenfoot.mousePressed(((Welt)getWorld()).f)){
            getWorld().removeObject(this);
        }
    }
    
    public void imager(){
        if(onOff==ON){
            setImage("SteckiA.png");
        }else if(onOff==OFF){
            setImage("SteckiO.png");
        }
    }
    
    public void onclicker(){
        if(Greenfoot.mousePressed(this)){
            if(onOff==ON){
                offbutton = new SteckiOff(this);
                getWorld().addObject(offbutton, 100, 150);
            }else if(onOff==OFF){
                onbutton = new SteckiOn(this);
                getWorld().addObject(onbutton, 100, 150);
            }
        }
    }
    
    public void stateChange(int state) {
        onOff = state;
        if(onbutton!=null) {
            getWorld().removeObject(onbutton);
            onbutton = null;
        }
        if(offbutton != null) {
            getWorld().removeObject(offbutton);
            offbutton = null;
        }
    } 
}
